Subject: Re: [PATCH 03/11] netfilter: don't use module_init/exit in core IPV4 code

From: Pablo Neira Ayuso <[email-masked]>
Date: Wed, 3 Jun 2015 18:04:29 +0200

On Sun, May 31, 2015 at 08:54:04PM -0400, Paul Gortmaker wrote:
> The file net/ipv4/netfilter.o is created based on whether
> CONFIG_NETFILTER is set.  However that is defined as a bool, and
> hence this file with the core netfilter hooks will never be
> modular.  So using module_init as an alias for __initcall can be
> somewhat misleading.
> 
> Fix this up now, so that we can relocate module_init from
> init.h into module.h in the future.  If we don't do this, we'd
> have to add module.h to obviously non-modular code, and that
> would be a worse thing.  Also add an inclusion of init.h, as
> that was previously implicit here in the netfilter.c file.
> 
> Note that direct use of __initcall is discouraged, vs. one
> of the priority categorized subgroups.  As __initcall gets
> mapped onto device_initcall, our use of subsys_initcall (which
> seems to make sense for netfilter code) will thus change this
> registration from level 6-device to level 4-subsys (i.e. slightly
> earlier).  However no observable impact of that small difference
> has been observed during testing, or is expected. (i.e. the
> location of the netfilter messages in dmesg remains unchanged
> with respect to all the other surrounding messages.)
> 
> As for the module_exit, rather than replace it with __exitcall,
> we simply remove it, since it appears only UML does anything
> with those, and even for UML, there is no relevant cleanup
> to be done here.
> 
> Cc: Pablo Neira Ayuso <[email-masked]>
> Cc: Patrick McHardy <[email-masked]>
> Cc: Jozsef Kadlecsik <[email-masked]>
> Cc: "David S. Miller" <[email-masked]>
> Cc: [email-masked]
> Cc: [email-masked]
> Signed-off-by: Paul Gortmaker <[email-masked]>

Acked-by: Pablo Neira Ayuso <[email-masked]>

Or I can integrate this into the nf-next tree if you prefer it.

Thanks.